'use strict'

var _interopRequireDefault = require('@babel/runtime/helpers/interopRequireDefault')

var _typeof = require('@babel/runtime/helpers/typeof')

Object.defineProperty(exports, '__esModule', {
  value: true,
})
exports['default'] = convertPropertyReplacement

var t = _interopRequireWildcard(require('@babel/types'))

var _convertToIdentifierExpressionPair = _interopRequireDefault(
  require('./convertToIdentifierExpressionPair')
)

var _convertToExpression = _interopRequireDefault(
  require('./convertToExpression')
)

function _getRequireWildcardCache(nodeInterop) {
  if (typeof WeakMap !== 'function') return null
  var cacheBabelInterop = new WeakMap()
  var cacheNodeInterop = new WeakMap()
  return (_getRequireWildcardCache = function _getRequireWildcardCache(
    nodeInterop
  ) {
    return nodeInterop ? cacheNodeInterop : cacheBabelInterop
  })(nodeInterop)
}

function _interopRequireWildcard(obj, nodeInterop) {
  if (!nodeInterop && obj && obj.__esModule) {
    return obj
  }

  if (
    obj === null ||
    (_typeof(obj) !== 'object' && typeof obj !== 'function')
  ) {
    return {
      default: obj,
    }
  }

  var cache = _getRequireWildcardCache(nodeInterop)

  if (cache && cache.has(obj)) {
    return cache.get(obj)
  }

  var newObj = {}
  var hasPropertyDescriptor =
    Object.defineProperty && Object.getOwnPropertyDescriptor

  for (var key in obj) {
    if (key !== 'default' && Object.prototype.hasOwnProperty.call(obj, key)) {
      var desc = hasPropertyDescriptor
        ? Object.getOwnPropertyDescriptor(obj, key)
        : null

      if (desc && (desc.get || desc.set)) {
        Object.defineProperty(newObj, key, desc)
      } else {
        newObj[key] = obj[key]
      }
    }
  }

  newObj['default'] = obj

  if (cache) {
    cache.set(obj, newObj)
  }

  return newObj
}

function convertPropertyReplacement(node) {
  switch (node.type) {
    case 'SpreadElement':
    case 'ObjectProperty':
      return node

    case 'ObjectTypeSpreadProperty': {
      var expr = (0, _convertToExpression['default'])(node)
      if (expr) return t.spreadElement(expr)
    }
  }

  var keyValue = (0, _convertToIdentifierExpressionPair['default'])(node)
  if (keyValue) return t.objectProperty(keyValue[0], keyValue[1])
  return node
}