"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = addMissingFields;

var _types = _interopRequireDefault(require("ast-types/lib/types"));

function addMissingFields(fork) {
  var types = fork.use(_types["default"]);
  var Type = types.Type;
  var def = Type.def,
      or = Type.or;
  var TypeAnnotation = or(def('TypeAnnotation'), def('TSTypeAnnotation'), null);
  var TypeParamInst = or(def('TypeParameterInstantiation'), def('TSTypeParameterInstantiation'), null);
  def('ArrayPattern').field('typeAnnotation', TypeAnnotation, function () {
    return null;
  });
  def('CallExpression').field('typeParameters', TypeParamInst, function () {
    return null;
  }).field('typeArguments', TypeParamInst, function () {
    return null;
  });
  def('NewExpression').field('typeParameters', TypeParamInst, function () {
    return null;
  }).field('typeArguments', TypeParamInst, function () {
    return null;
  });
  def('ImportSpecifier').field('importKind', or('value', 'type', 'typeof', null), function () {
    return null;
  });
  def('Program').bases('Block');
  def('BlockStatement').bases('Block');
  def('TSModuleBlock').bases('Block');
}