"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = cloneNode;

function cloneNode(node) {
  var result = {};

  for (var field in node) {
    switch (field) {
      case 'start':
      case 'end':
      case 'loc':
      case 'range':
        continue;
    }

    var value = node[field];
    result[field] = cloneValue(value);
  }

  return result;
}

function cloneValue(value) {
  if (Array.isArray(value)) {
    return value.map(cloneValue);
  }

  if (value instanceof Object) {
    var obj = value;

    if (typeof obj.type === 'string') {
      return cloneNode(value);
    }

    var result = {};

    for (var key in obj) {
      result[key] = cloneValue(obj[key]);
    }

    return result;
  }

  return value;
}