import { IpcTransformResult } from './ipc';
import AstxWorker from './AstxWorker';
import AsyncPool from './AsyncPool';
import { RunTransformOptions, Progress } from './runTransform';
import { RunTransformOnFileOptions } from './runTransformOnFile';
export default class AstxWorkerPool {
    pool: AsyncPool<AstxWorker>;
    constructor({ capacity }?: {
        capacity?: number;
    });
    end(): Promise<void>;
    runTransformOnFile(options: RunTransformOnFileOptions): Promise<IpcTransformResult>;
    runTransform({ gitignore, transform, transformFile, paths, exclude, cwd, config, signal, queueCapacity, }: RunTransformOptions & {
        queueCapacity?: number;
    }): AsyncIterable<{
        type: 'result';
        result: IpcTransformResult;
    } | Progress>;
}
