/// <reference types="node" />
import { AstxConfig } from '../AstxConfig';
import { Transform, TransformResult } from '../Astx';
import Gitignore from 'gitignore-fs';
export declare type Progress = {
    type: 'progress';
    completed: number;
    total: number;
    globDone: boolean;
};
export declare type RunTransformOptions = {
    gitignore?: Gitignore | null;
    transform?: Transform;
    transformFile?: string;
    paths?: readonly string[];
    exclude?: string;
    cwd?: string;
    config?: Partial<AstxConfig>;
    signal?: AbortSignal;
};
export default function runTransform({ gitignore, transform: _transform, transformFile, paths: _paths, exclude, cwd, config, signal, }: RunTransformOptions): AsyncIterable<{
    type: 'result';
    result: TransformResult;
} | Progress>;
